<?php

namespace Drupal\linkit_sharepoint\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Url;

/**
 * Plugin implementation of the 'Sharepoint Document' formatter.
 *
 * @FieldFormatter(
 *   id = "linkit_sharepoint_document",
 *   label = @Translation("Sharepoint Document"),
 *   field_types = {
 *     "linkit_sharepoint_document"
 *   }
 * )
 */
class DocumentFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $element = [];
    foreach ($items as $delta => $item) {
      $url = Url::fromRoute('linkit_sharepoint.deliver', ['id' => $item->value])->toString();
      $element[$delta] = [
        '#markup' => '<a href="' . $url . '">' . $url . '</a>',
      ];
    }
    return $element;
  }

}
