<?php

namespace Drupal\linkit_sharepoint\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Defines the 'linkit_sharepoint_document' field widget.
 *
 * @FieldWidget(
 *   id = "linkit_sharepoint_document",
 *   label = @Translation("Sharepoint Document"),
 *   field_types = {"linkit_sharepoint_document"},
 * )
 */
class DocumentWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element['value'] = $element + [
      '#type' => 'textfield',
      '#default_value' => isset($items[$delta]->value) ? $items[$delta]->value : NULL,
      '#description' => t('Enter a comma-separated list of words to describe your view.'),
      '#autocomplete_route_name' => 'linkit_sharepoint.autocomplete',
    ];
    return $element;
  }

}
