<?php

namespace Drupal\linkit_sharepoint\Plugin\Linkit\Matcher;

use Drupal\linkit\MatcherBase;
use Drupal\linkit_sharepoint\Controller\SharepointController;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Sharepoint matcher class.
 *
 * @Matcher(
 *   id = "sharepoint_matcher",
 *   label = @Translation("Sharepoint Matcher"),
 * )
 */
class SharepointMatcher extends MatcherBase {

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition
    );
  }

  /**
   * {@inheritdoc}
   */
  public function getMatches($string) {
    $sp = new SharepointController();
    $items = $sp->search($string);
    $matches = [];
    foreach ($items as $item) {
      $matches[] = [
        'title' => $item->Title,
        'description' => $item->EncodedAbsUrl,
        'path' => '/deliver/' . $item->Id,
        'group' => 'Sharepoint Documents',
      ];
    }
    return $matches;
  }

}
